// BeOS BeDaliClock by Abraham Flaxman (bedev@kenlaw.com)
//   Copyright (C) 1996, 1997
//	Revised 6/97 for DR9AA
//	revised 7/97 by AbiSoft for PR
//	
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2, or (at your option)
//   any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 

#pragma once on
#include "BeDaliClock.h"
Preferences gPrefs("x-kenlaw-BeDaliClock");
PreferenceSet gSettings(gPrefs, "settings", true);     

main() {
	MyApplication *myApplication;
	
	myApplication = new MyApplication();
	myApplication->Run();
	
	delete(myApplication);
	
	return 0;
}
const char *app_signature = "application/x-kenlaw-BeDaliClock";     

MyApplication::MyApplication()
        :BApplication(app_signature) {
	
	SmartSingleWindow *aWindow;
	const void * data;
	bool	ArmyFlag = false, ButtonOneShowsDateFlag = false;
	size_t	size;
	uint32 type = '    ';
	if (gSettings.GetData("numColor", data, size, type) || (type != B_STRING_TYPE))
		;
	else	
			strcpy(StartingColor, (char *) data);
	if (gSettings.GetData("armytime", data, size, type) || (type != B_BOOL_TYPE))
		;
	else
		memcpy( (void *) &ArmyFlag, data, sizeof(bool));
	
	if (gSettings.GetData("ButtonOneShowsDate", data, size, type) || (type != B_BOOL_TYPE))
		;
	else
		memcpy( (void *) &ButtonOneShowsDateFlag, data, sizeof(bool));		
	
	BRect aRect(50.0, 50.0, 50.0 + WIN_WIDTH, 50.0 + WIN_HEIGHT);
	aWindow = new SmartSingleWindow(aRect, "BeDaliClock",
				B_TITLED_WINDOW, B_NOT_RESIZABLE|B_NOT_ZOOMABLE|B_WILL_ACCEPT_FIRST_CLICK,
				B_ALL_WORKSPACES);
	aRect.OffsetTo(B_ORIGIN);
	
	
	aView = new BeDaliClockView(aRect, StartingColor, ArmyFlag, ButtonOneShowsDateFlag);
	aWindow->AddChild(aView);
	
	// make window visible
	aWindow->Show();
	
}
bool
MyApplication::QuitRequested()
{
	strcpy(StartingColor, aView->GetNumberColor());
	bool save;
	if (gSettings.SetData("numColor", StartingColor, 
			sizeof(StartingColor), B_STRING_TYPE))
		puts("Cannot set backgroundColor");
   
	save = aView->GetArmyTime();
	if (gSettings.SetData("armytime", &save, 
			sizeof(bool), B_BOOL_TYPE))
		puts("Cannot save ArmyTimeFlag");
	save = aView->GetButtonOneShowsDate();
	
	if (gSettings.SetData("ButtonOneShowsDate", &save, 
		sizeof(bool), B_BOOL_TYPE))	
		puts("Cannot save ButtonOneShowsDate");
	if (gSettings.Save())
		puts("Cannot save settings");
	return true;	
}

