//  BeOS daliclock originally by Abraham Flaxman (bedev@kenlaw.com)
//   Copyright (C) 1996, 1997
//	MODIFIED FOR DR9AA 6/97
//	Modified for PR knf 7/97
//	
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2, or (at your option)
//   any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the Free Software
//   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// 
#pragma once on

#include <InterfaceKit.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include "OptionsWindow.h"
#include <Screen.h>


#define WIN_WIDTH 224
#define WIN_HEIGHT 64
#define CHAR_WIDTH 32


#pragma export on
	
class OptionsWindow;
class BeDaliClockView : public BView {
enum {
		CLOCK_MODE,		//display time
		DATE_MODE,		//display date
		TO_DATE_MODE,	//morph from time to date
		TO_CLOCK_MODE,	//morph from date to time
		ALMOST_TO_DATE_MODE	//after current morph completes, enter TO_DATE_MODE
	};
public:
	
	BeDaliClockView(BRect area, char *NumColor, bool ArmyTimeFlag,
							bool ButtonOneShowsDateFlag);
	~BeDaliClockView();
	BeDaliClockView(BMessage *data);
	virtual void Draw(BRect area);
	virtual void MouseDown(BPoint point);
	
	//void SetArmyTimeMode(bool mode);
	virtual status_t Archive(BMessage *data, bool deep = true) const;
	static BeDaliClockView	*Instantiate(BMessage *data);
	virtual void MessageReceived(BMessage *msg);
	void	AboutRequested();
	void	SetOptionsWindowFlag(bool flag);
	void	SetArmyTime(bool Flag);
	void	SetButtonOneShowsDate(bool flag);
	void	SetNumberColor(const char *colorname);
	inline bool	GetArmyTime() {return army_time;};
	inline bool	GetButtonOneShowsDate(){return ButtonOneShowsDate;};
	inline char	*GetNumberColor() {return wColorbuf;};
	
private:
	void MyGoFunc();
	void InitFunc(BRect area, char *wColor, bool flag, bool aflag, bool bflag);	// for repolicant
	static long _run_clock(void *data);
	inline bool morePixOnLine(long &t, long x, long y, BBitmap *line);
	long nextPixOnLine(long x, long y, BBitmap *line);
	inline void setPix(long x, long y, uchar color, BBitmap *line);
	int indexFromChar(char ch);
	sem_id	clocksem;
	thread_id painter;
	BBitmap **digits;
	BBitmap *offscreen;
	int mode;		//CLOCK_MODE, DATE_MODE, etc.
	time_t timer;		//last time, as returned by time() 
	float pct;		//pct of morph completed (between 0.0 and 1.0)
	char *old_msg, *new_msg;	//old and new time (or date)
	bool army_time;		//24 hours or 12?
	OptionsWindow	*aptr;
	bool	IsOptionsWindowUp;
	bool	ButtonOneShowsDate;
	char wColorbuf[128];
	uchar white;
	uchar black;
	rgb_color BeRgbColorFromName(const char *colorname);
};
#pragma export off
